#include "usesdp.h"

void fshow(Node * ptr)
{
	if (ptr->next == NULL){
		int flag = 1;
		Node * temp = ptr;
		while (temp != NULL){
			ptr = temp;
			while (ptr != NULL){
				if (ptr->conj != NULL){
					flag = -1;
					fprintf(fp_show, "(");
				}
				for (int i = 0; i < ptr->a[0]; i++){
					fprintf(fp_show, "(");
					if (ptr->a[i + 1] > 0){
						for (int j = 0, k = 0; j < ptr->a[i + 1]; j++){
							if (k == 1 && ptr->c[i][j] > 0)
								fprintf(fp_show, " +");
							else
								fprintf(fp_show, " ");
							k = 1;
							if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
								if (ptr->b[i][2 * j] == 0)
									fprintf(fp_show, "%.6lf", ptr->c[i][j]);
								else
									fprintf(fp_show, "%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
							}
							else{
								if (ptr->b[i][2 * j] == 0){
									fprintf(fp_show, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
								else if (ptr->b[i][2 * j + 1] == 0){
									fprintf(fp_show, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
								}
								else{
									fprintf(fp_show, "%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
							}
						}
						fprintf(fp_show, ">=0");
					}
					else{
						for (int j = 0, k = 0; j < -ptr->a[i + 1]; j++){
							if (k == 1 && ptr->c[i][j] > 0)
								fprintf(fp_show, " +");
							else
								fprintf(fp_show, " ");
							k = 1;
							if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
								if (ptr->b[i][2 * j] == 0)
									fprintf(fp_show, "%.6lf", ptr->c[i][j]);
								else
									fprintf(fp_show, "%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
							}
							else{
								if (ptr->b[i][2 * j] == 0){
									fprintf(fp_show, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
								else if (ptr->b[i][2 * j + 1] == 0){
									fprintf(fp_show, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
								}
								else{
									fprintf(fp_show, "%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
							}
						}
						fprintf(fp_show, ">0");
					}
					if (i == ptr->a[0] - 1){
						fprintf(fp_show, ")");
					}
					else{
						fprintf(fp_show, ")");
					}
				}
				ptr = ptr->conj;
				if (ptr != NULL){
					fprintf(fp_show, "");
				}
			}
			temp = temp->with;
			if (flag == -1){
				fprintf(fp_show, ")");
				flag = 1;
			}
			if (temp != NULL){
				fprintf(fp_show, "");
			}
		}
		return;
	}


	fprintf(fp_show, "(");
	int ert;
	if (ptr->a[1] > 0){
		ert = ptr->a[1];
	}
	else{
		ert = -ptr->a[1];
	}
	for (int j = 0, k = 0; j < ert; j++){
		if (k == 1 && ptr->c[0][j] > 0)
			fprintf(fp_show, " +");
		else
			fprintf(fp_show, " ");
		k = 1;
		if (ptr->b[0][2 * j] == ptr->b[0][2 * j + 1]){
			if (ptr->b[0][2 * j] == 0)
				fprintf(fp_show, "%.6lf", ptr->c[0][j]);
			else
				fprintf(fp_show, "%.6lf*%s^2", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
		}
		else{
			if (ptr->b[0][2 * j] == 0){
				fprintf(fp_show, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
			else if (ptr->b[0][2 * j + 1] == 0){
				fprintf(fp_show, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
			}
			else{
				fprintf(fp_show, "%.6lf*%s*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
		}
	}
	fprintf(fp_show, ">0)((");

	for (int j = 0, k = 0; j < ert; j++){
		if (k == 1 && ptr->c[0][j] > 0)
			fprintf(fp_show, " +");
		else
			fprintf(fp_show, " ");
		k = 1;
		if (ptr->b[0][2 * j] == ptr->b[0][2 * j + 1]){
			if (ptr->b[0][2 * j] == 0)
				fprintf(fp_show, "%.6lf", ptr->c[0][j]);
			else
				fprintf(fp_show, "%.6lf*%s^2", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
		}
		else{
			if (ptr->b[0][2 * j] == 0){
				fprintf(fp_show, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
			else if (ptr->b[0][2 * j + 1] == 0){
				fprintf(fp_show, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
			}
			else{
				fprintf(fp_show, "%.6lf*%s*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
		}
	}
	fprintf(fp_show, "=0)[");
	fshow(ptr->next);
	fprintf(fp_show, "])");
}



void fshowToFile(FILE * fp,Node * ptr)
{
	if (ptr->next == NULL){
		int flag = 1;
		Node * temp = ptr;
		while (temp != NULL){
			ptr = temp;
			int first = 1;
			while (ptr != NULL){
				if (ptr->conj != NULL && first == 1){
					first = 0;
					flag = -1;
					fprintf(fp, "(");
				}
				for (int i = 0; i < ptr->a[0]; i++){
					fprintf(fp, "(");
					if (ptr->a[i + 1] > 0){
						for (int j = 0, k = 0; j < ptr->a[i + 1]; j++){
							if (k == 1 && ptr->c[i][j] > 0)
								fprintf(fp, " +");
							else
								fprintf(fp, " ");
							k = 1;
							if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
								if (ptr->b[i][2 * j] == 0)
									fprintf(fp, "%.6lf", ptr->c[i][j]);
								else
									fprintf(fp, "%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
							}
							else{
								if (ptr->b[i][2 * j] == 0){
									fprintf(fp, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
								else if (ptr->b[i][2 * j + 1] == 0){
									fprintf(fp, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
								}
								else{
									fprintf(fp, "%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
							}
						}
						fprintf(fp, ">=0");
					}
					else{
						for (int j = 0, k = 0; j < -ptr->a[i + 1]; j++){
							if (k == 1 && ptr->c[i][j] > 0)
								fprintf(fp, " +");
							else
								fprintf(fp, " ");
							k = 1;
							if (ptr->b[i][2 * j] == ptr->b[i][2 * j + 1]){
								if (ptr->b[i][2 * j] == 0){
									fprintf(fp, "%.6lf", ptr->c[i][j]);
								}
								else{
									fprintf(fp, "%.6lf*%s^2", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
								}
							}
							else{
								if (ptr->b[i][2 * j] == 0){
									fprintf(fp, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
								else if (ptr->b[i][2 * j + 1] == 0){
									fprintf(fp, "%.6lf*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1]);
								}
								else{
									fprintf(fp, "%.6lf*%s*%s", ptr->c[i][j], varnamelist[ptr->b[i][2 * j] - 1], varnamelist[ptr->b[i][2 * j + 1] - 1]);
								}
							}
						}
						fprintf(fp, ">0");
					}
					if (i == ptr->a[0] - 1){
						fprintf(fp, ")");
					}
					else{
						fprintf(fp, ")and");
					}
				}
				ptr = ptr->conj;
				if (ptr != NULL){
					fprintf(fp, "and");
				}
			}
			temp = temp->with;
			if (flag == -1){
				fprintf(fp, ")");
				flag = 1;
			}
			if (temp != NULL){
				fprintf(fp, "or");
			}
		}
		return;
	}

	fprintf(fp, "(");
	int ert;
	if (ptr->a[1] > 0){
		ert = ptr->a[1];
	}
	else{
		ert = -ptr->a[1];
	}
	for (int j = 0, k = 0; j < ert; j++){
		if (k == 1 && ptr->c[0][j] > 0)
			fprintf(fp, " +");
		else
			fprintf(fp, " ");
		k = 1;
		if (ptr->b[0][2 * j] == ptr->b[0][2 * j + 1]){
			if (ptr->b[0][2 * j] == 0)
				fprintf(fp, "%.6lf", ptr->c[0][j]);
			else
				fprintf(fp, "%.6lf*%s^2", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
		}
		else{
			if (ptr->b[0][2 * j] == 0){
				fprintf(fp, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
			else if (ptr->b[0][2 * j + 1] == 0){
				fprintf(fp, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
			}
			else{
				fprintf(fp, "%.6lf*%s*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
		}
	}
	fprintf(fp, ">0)or((");

	for (int j = 0, k = 0; j < ert; j++){
		if (k == 1 && ptr->c[0][j] > 0)
			fprintf(fp, " +");
		else
			fprintf(fp, " ");
		k = 1;
		if (ptr->b[0][2 * j] == ptr->b[0][2 * j + 1]){
			if (ptr->b[0][2 * j] == 0)
				fprintf(fp, "%.6lf", ptr->c[0][j]);
			else
				fprintf(fp, "%.6lf*%s^2", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
		}
		else{
			if (ptr->b[0][2 * j] == 0){
				fprintf(fp, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
			else if (ptr->b[0][2 * j + 1] == 0){
				fprintf(fp, "%.6lf*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1]);
			}
			else{
				fprintf(fp, "%.6lf*%s*%s", ptr->c[0][j], varnamelist[ptr->b[0][2 * j] - 1], varnamelist[ptr->b[0][2 * j + 1] - 1]);
			}
		}
	}
	fprintf(fp, "=0)and[");
	fshowToFile(fp,ptr->next);
	fprintf(fp, "])");
}