#include "higher.h"

int solve_higher_problem_for_web(const char * myfilename)
{
	char * input = (char *)malloc(sizeof(char)* 300);
	int inputsize = 0;
	char * input2 = (char *)malloc(sizeof(char)* 300);

	// head
	printf("# Fill this template file please.\n\n");

	// Variable List
	printf("A = [");
	for (int i = 0; i < varsize; i++){
		if (i){
			printf(" ");
		}
		printf("%s", varNameList[i]);
	}
	printf("]\n\n");


	int scan_index;
	if (phipsiOutput[0] == '\n'){
		scan_index = 1;
	}
	else {
		scan_index = 0;
	}
	int phi_to_psi = 0;

	// phi
	int fNum = 0;
	inputsize = 0;
	for (; scan_index < phipsiOutputCapacity; scan_index++) {
		if (phipsiOutput[scan_index] == '\n') {
			if (phi_to_psi) {
				break;
			}
			else {
				phi_to_psi = 1;
			}
			if (inputsize >= 3){
				if (input[inputsize - 3] == '>') {
					// >=0
					fNum++;
					input[inputsize - 3] = '\0';
					printf("f%d = %s\n", fNum, input);
					inputsize = 0;
				}
				else if (input[inputsize - 2] == '>') {
					// >0
					fNum++;
					input[inputsize - 2] = '\0';
					printf("f%d = %s\n", fNum, input);
					inputsize = 0;
				}
				else {
					// =0
					fNum++;
					input[inputsize - 2] = '\0';
					printf("f%d = %s\n", fNum, input);
					inputsize = 0;
				}
			}
			else{
				continue;
			}
		}
		else if (phipsiOutput[scan_index] == ':') {
			inputsize = 0;
		}
		else {
			phi_to_psi = 0;
			input[inputsize] = phipsiOutput[scan_index];
			inputsize++;
		}
	}


	/*psi*/
	int hNum = 0;
	inputsize = 0;
	for (; scan_index < phipsiOutputCapacity; scan_index++) {
		if (phipsiOutput[scan_index] == '\n') {
			if (inputsize >= 3){
				if (input[inputsize - 3] == '>') {
					// >=0
					hNum++;
					input[inputsize - 3] = '\0';
					printf("h%d = %s\n", hNum, input);
					inputsize = 0;
				}
				else if (input[inputsize - 2] == '>') {
					// >0
					hNum++;
					input[inputsize - 2] = '\0';
					printf("h%d = %s\n", hNum, input);
					inputsize = 0;
				}
				else {
					// =0
					hNum++;
					input[inputsize - 2] = '\0';
					printf("h%d = %s\n", hNum, input);
					inputsize = 0;
				}
			}
			else{
				continue;
			}
		}
		else if (phipsiOutput[scan_index] == ':') {
			inputsize = 0;
		}
		else {
			input[inputsize] = phipsiOutput[scan_index];
			inputsize++;
		}
	}


	printf("\n# Monomial templates (you can add more in the same form).\n");
	//printf("M1 = monomial(A, [0])\n");
	//printf("M2 = monomial(A, [0 1])\n");
	//printf("M3 = monomial(A, [0 1 2])\n");
	for (int i = 0; i <= 4; i++){
		printf("M%d = monomial(A, [", i);
		for (int j = 0; j <= i; j++){
			printf("%d", j);
			if (j != i){
				printf(" ");
			}
		}
		printf("])\n");
	}
	printf("\n");

	printf("# Set polynomial templates by replacing '?' with ");
	int Mnum = 2;
	for (int i = 0; i <= Mnum; i++){
		printf("M%d", i);
		if (i == Mnum){
			printf(" ");
		}
		else 		if (i == Mnum - 1){
			printf(" or ");
		}
		else{
			printf(", ");
		}
	}
	printf("etc.\n");

	printf("s0 = sos(?)\n");

	for (int i = 0; i < fNum; i++){
		if (phi_equals[i + 1]){
			printf("s%d = poly(?)\n", i + 1);
		}
		else {
			printf("s%d = sos(?)\n", i + 1);
		}
	}

	for (int i = 0; i < hNum; i++){
		if (psi_equals[i + 1]){
			printf("t%d = poly(?)\n", i + 1);
		}
		else {
			printf("t%d = sos(?)\n", i + 1);
		}
	}

	printf("\ninterp(s0");
	for (int i = 0; i < fNum; i++){
		printf("+f%d*s%d", i + 1, i + 1);
	}
	printf(",");
	for (int i = 0; i < hNum; i++){
		if (i == 0)
			printf("h%d*t%d", i + 1, i + 1);
		else
			printf("+h%d*t%d", i + 1, i + 1);
	}
	printf(")\n");

	return 0;
}

