#include <Windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
/*
 * Include CSDP declarations so that we'll know the calling interfaces.
 */

#include "declarations.h"
#include "usesdp.h"

//SetErrorMode( SEM_NOGPFAULTERRORBOX |SEM_NOGPFAULTERRORBOX);

int interp2(const char * myfilename)
{
	clock_t time_start, time_finish;
	time_start = clock();

	cf_ptr = NULL;

	char * phipsiOutput = (char *)malloc(sizeof(char)* 2000);
	int phipsiOutputCapacity = 0;

	int f1size = 0;
	int f2size = 0;
	int g1size = 0;
	int g2size = 0;

	int varsize = 0;
	original_varsize = 0;
	int * function_list_common;
	int * function_list_phi;
	int * function_list_psi;
	function_list_common = (int *)malloc(sizeof(int)* (100));
	function_list_phi = (int *)malloc(sizeof(int)* (100));
	function_list_psi = (int *)malloc(sizeof(int)* (100));
	int * variable_common = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
	int * variable_phi = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
	int * variable_psi = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
	int examine_higher = 0;
	//int ** data;

	/*
	ʼ
	*/
	char * foutname = (char *)malloc(sizeof(char)*(strlen(myfilename) + 9));
	foutname[0] = 'r';
	foutname[1] = 'e';
	foutname[2] = 's';
	foutname[3] = 'u';
	foutname[4] = 'l';
	foutname[5] = 't';
	foutname[6] = '_';
	for (int i = 0; i <= strlen(myfilename); i++){
		foutname[i + 7] = myfilename[i];
		if (i == strlen(myfilename)){
			foutname[i + 7] = '\0';
		}
	}
	//if (WEB_VERSION){
	//	fp_show = NULL;
	//}
	//else{
	fp_show = fopen(foutname, "w");
	if (fp_show == NULL){
		printf("The file doesn't exist.");
		exit(1);
	}
	//}

	FILE * fp = fopen(myfilename, "r");
	if (fp == NULL){
		printf("The file doesn't exist.");
		exit(1);
	}

	char input[500] = { "\0" };
	int inputtemp = 0;
	int inputrow = 1; //Чеĸ
	int namenum = 0;

	char input2[500] = { "\0" };
	int conssize = 0;
	funcsize = 0;
	N_phi = NULL;
	N_psi = NULL;
	N_mix = NULL;
	//N0size = 0;

	/*ƥ*/
	int* kuohao_stack = (int *)malloc(sizeof(int)* 30);
	int stack_cap = 0;

	int * qresult = NULL;

	Node * phi_constraints = (Node *)malloc(sizeof(Node));
	Node * psi_constraints = (Node *)malloc(sizeof(Node));

	phi_equal_constraints = (Node *)malloc(sizeof(Node));
	phi_equal_constraints->a = NULL;
	phi_equal_constraints->b = NULL;
	phi_equal_constraints->c = NULL;
	phi_equal_constraints->d = NULL;
	psi_equal_constraints = (Node *)malloc(sizeof(Node));
	psi_equal_constraints->a = NULL;
	psi_equal_constraints->b = NULL;
	psi_equal_constraints->c = NULL;
	psi_equal_constraints->d = NULL;

	int error_line_record = 0;
	int is_a_end = 1;

	bool iseof = false;
	while (input[inputtemp - 1] != EOF && iseof == false){
		error_line_record++;
		inputtemp = 0;
		while ((input[inputtemp++] = fgetc(fp)) != '\n' && input[inputtemp - 1] != EOF);

		if (input[inputtemp - 1] == EOF){
			input[inputtemp - 1] = '\n';
			iseof = true;
		}
		input[inputtemp] = '\0';
		if (inputtemp < 1){

			exit(1);
		}

		//#ţע
		int examine_sharp = 0;
		while (input[examine_sharp] != '#' && examine_sharp < inputtemp){
			examine_sharp++;
		}
		if (examine_sharp < inputtemp){
			input[examine_sharp] = '\n';
			input[examine_sharp + 1] = '\0';
			inputtemp = examine_sharp + 1;
		}

		for (int i = 0, j = 0; i < inputtemp;){
			if (input[i] == '\t'){
				i++;
			}
			else{
				input[j] = input[i];
				i++;
				j++;
			}
		}
		int inputExamine = input_examine(input, inputtemp);
		if (inputExamine == 1){
			printf("\nSyntax error at line %d.\n", error_line_record);
			exit(1);
		}
		else{
			inputtemp = strlen(input);
		}

		if (inputtemp == 1){
			continue;
		}

		if (inputrow == 1){

			const char * firstLineVerification = "variable number:\0";

			if (inputtemp < 16){
				printf("\nSyntax error at line %d.\n", error_line_record);
				exit(1);
			}
			for (int i = 0; i < 16; i++){
				if (firstLineVerification[i] != input[i]){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
			}

			for (int i = 16, j = 0; i <= inputtemp; i++){
				if (input[i] != ' ' && input[i] != '\n'){
					input2[j] = input[i];
					j++;
				}
			}

			for (int i = 0; i < strlen(input2); i++){
				if (!isdigit(input2[i])){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
			}

			varsize = atoi(input2);
			original_varsize = varsize;
			varnamelist = (char **)malloc(sizeof(char *)* (VARSIZE_MAXIMUM));


			for (int i = 0; i < original_varsize; i++){
				variable_common[i] = 0;
				variable_phi[i] = 0;
				variable_psi[i] = 0;
			}

			inputrow = 2;
			continue;
		}

		if (inputrow == 2){

			const char * secondLineVerification = "variable list:\0";

			if (inputtemp < 14){
				printf("\nSyntax error at line %d.\n", error_line_record);
				exit(1);
			}
			for (int i = 0; i < 14; i++){
				if (secondLineVerification[i] != input[i]){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
			}

			int search_colon = 0;

			while (input[search_colon] != '['){
				search_colon++;
			}

			int read = search_colon + 1;
			//printf("read1 = %d\n", read);

			while (input[read] != ']'){
				while (input[read] == ' '){
					read++;
				}
				int read2 = read;
				while (input[read2] != ' ' && input[read2] != ']'){
					read2++;
				}
				if (read2 == read) continue;
				if (namenum == varsize){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
				varnamelist[namenum] = (char *)malloc(sizeof(char)*(read2 - read + 2));
				for (int i = read; i < read2; i++){
					varnamelist[namenum][i - read] = input[i];
				}
				varnamelist[namenum][read2 - read] = '\0';
				if (isdigit(varnamelist[namenum][0])){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
				read = read2;
				namenum++;
			}
			inputrow = 3;
			continue;
		}

		if (inputrow == 3){

			const char * thirdLineVerification = "uninterpreted function number:\0";

			if (inputtemp < 30){
				printf("\nSyntax error at line %d.\n", error_line_record);
				exit(1);
			}
			for (int i = 0; i < 30; i++){
				if (thirdLineVerification[i] != input[i]){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
			}

			for (int i = 30, j = 0; i <= inputtemp; i++){
				if (input[i] != ' '&&input[i] != '\n'){
					input2[j] = input[i];
					j++;
				}
			}
			for (int i = 0; i < strlen(input2); i++){
				if (!isdigit(input2[i])){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
			}
			funcsize = atoi(input2);
			funcnamelist = (char **)malloc(sizeof(char *)* (funcsize + 1));

			for (int i = 0; i < funcsize; i++){
				function_list_common[i] = 0;
				function_list_phi[i] = 0;
				function_list_psi[i] = 0;
			}
			N_half = (Node **)malloc(sizeof(Node *)* MY_MALLOC_SIZE);
			for (int i = 0; i < MY_MALLOC_SIZE; i++){
				N_half[i] = NULL;
			}

			if (funcsize > 0){
				has_a_euf = true;
			}
			else{
				has_a_euf = false;
			}
			inputrow = 4;
			continue;
		}

		if (inputrow == 4){

			const char * fourthLineVerification = "uninterpreted function list:\0";

			if (inputtemp < 28){
				printf("\nSyntax error at line %d.\n", error_line_record);
				exit(1);
			}
			for (int i = 0; i < 28; i++){
				if (fourthLineVerification[i] != input[i]){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
			}

			int search_colon = 0;

			while (input[search_colon] != '['){
				search_colon++;
			}

			namenum = 0;

			int read = search_colon + 1;
			//printf("read = %d\n", read);
			while (input[read] != ']'){
				while (input[read] == ' '){
					read++;
				}
				int read2 = read;
				while (input[read2] != ' ' && input[read2] != ']'){
					read2++;
				}
				if (read2 == read) continue;
				if (namenum == funcsize){
					printf("\nSyntax error at line %d.\n", error_line_record);
					exit(1);
				}
				funcnamelist[namenum] = (char *)malloc(sizeof(char)*(read2 - read + 2));
				for (int i = read; i < read2; i++){
					funcnamelist[namenum][i - read] = input[i];
				}
				funcnamelist[namenum][read2 - read] = '\0';
				if (isdigit(funcnamelist[namenum][0])){
					printf("The beginning of variable name can't be a digit.\n");
					exit(1);
				}
				read = read2;
				namenum++;
			}
			inputrow = 5;
			continue;
		}

		if (inputtemp > 18 && input[18] == ':'){
			if (input[16] == 'h'){//h means phi, s means psi
				for (int i = 19, j = 0; i < inputtemp; i++){
					if (input[i] != ' '){
						input2[j] = input[i];
						j++;
					}
				}
				int temp = atoi(input2);
				if (temp <= 0){
					printf("The number of constraints is expected to be a positive integer.\n");
				}
				is_a_end += temp;
				phi_constraints->a = (int *)malloc(sizeof(int)* (temp + 3));
				phi_constraints->a[0] = temp;
				phi_constraints->b = (int **)malloc(sizeof(int *)*(temp + 2));
				for (int i = 0; i < temp; i++){
					phi_constraints->b[i] = (int *)malloc(sizeof(int)*varsize * (varsize + 2));
				}
				phi_constraints->c = (double **)malloc(sizeof(double *)*(temp + 2));
				for (int i = 0; i < temp; i++){
					phi_constraints->c[i] = (double *)malloc(sizeof(double)*varsize * (varsize + 2) / 2);
				}
				phi_equals = (int *)malloc(sizeof(int)* (temp + 3));
				for (int i = 0; i <= temp; i++){
					phi_equals[i] = 0;
				}
				//printf("\nphi:\n");
				if (!inputType){
					phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, "phi:\n");
				}
				continue;
			}
			else if (input[16] == 's'){//h means phi, s means psi
				conssize = 0;
				for (int i = 19, j = 0; i < inputtemp; i++){
					if (input[i] != ' '){
						input2[j] = input[i];
						j++;
					}
				}
				int temp = atoi(input2);
				is_a_end += temp;
				if (temp <= 0){
					printf("The number of constraints is expected to be a positive integer.\n");
				}
				psi_constraints->a = (int *)malloc(sizeof(int)* (temp + 3));
				psi_constraints->a[0] = temp;
				psi_constraints->b = (int **)malloc(sizeof(int *)*(temp + 2));
				for (int i = 0; i < temp; i++){
					psi_constraints->b[i] = (int *)malloc(sizeof(int)*varsize * (varsize + 2));
				}
				psi_constraints->c = (double **)malloc(sizeof(double *)*(temp + 1));
				for (int i = 0; i < temp; i++){
					psi_constraints->c[i] = (double *)malloc(sizeof(double)*varsize * (varsize + 2) / 2);
				}
				psi_equals = (int *)malloc(sizeof(int)* (temp + 3));
				for (int i = 0; i <= temp; i++){
					psi_equals[i] = 0;
				}
				inputrow = 6;
				if (!inputType){
					//printf("\npsi:\n");
					phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, "\npsi:\n");
				}
				continue;
			}
			else{
				printf("\nSyntax error at line %d.\n", error_line_record);
				exit(1);
			}
		}

		/*ȥո*/
		int inputtemp2 = 0;
		for (int i = 0; i <= inputtemp; i++){
			if (input[i] != ' '){
				input[inputtemp2] = input[i];
				inputtemp2++;
			}
		}
		inputtemp = inputtemp2 - 1;
		if (!inputType){
			//printf("%s", input);
			phipsiOutputCapacity += sprintf(phipsiOutput + phipsiOutputCapacity, "%s", input);
		}
		//λ
		int tempa = 0;
		//λ
		int tempb = 0;
		/**/
		for (int i = 0; i < inputtemp; i++){
			if (input[i] == '('){
				//һ
				kuohao_stack[stack_cap] = i;
				stack_cap++;

			}
			if (input[i] == ')'){
				if (stack_cap == 0){
					printf("\nSyntax error at line %d.\n", error_line_record);
				}
				else{
					tempa = kuohao_stack[stack_cap - 1]; //λ
					tempb = i; //λ

					/*һҵĸδͺţfunc_num_temp*/
					int func_name_search = tempa - 1;//input[func_name_search<=x<tempa]Ϊδͺ
					while (func_name_search >= 0
						&& input[func_name_search] != '+'
						&& input[func_name_search] != '-'
						&& input[func_name_search] != '*'
						&& input[func_name_search] != ' '
						&& input[func_name_search] != '('){
						func_name_search--;
					}
					func_name_search++;
					input[tempa] = '\0';
					int func_num_temp = 0; //ƥŶӦδͺ
					for (int ii = 0; ii < funcsize; ii++){
						if (strcmp(&input[func_name_search], funcnamelist[ii]) == 0){
							func_num_temp = ii;
							break;
						}
					}
					input[tempa] = '(';
					/*һ*/
					if (inputrow == 5){
						function_list_phi[func_num_temp] = 1;
					}
					else{
						function_list_psi[func_num_temp] = 1;
					}

					/*¼ƥеıʽ*/
					//ֻһ//
					int nn = tempa + 1;
					int flag = 1;

					int * domma_set = (int *)malloc(sizeof(int)* (tempb - tempa + 1));
					int domma_set_size = 1;
					domma_set[0] = tempa;

					for (int mm = tempa + 1; mm < tempb; mm++){
						if (input[mm] == ','){
							domma_set[domma_set_size] = mm;
							domma_set_size++;
						}
					}
					domma_set[domma_set_size] = tempb;
					domma_set_size++;

					Node * new_ptr = (Node *)malloc(sizeof(Node));
					new_ptr->a = (int *)malloc(sizeof(int)* 4);
					for (int a_i = 0; a_i < 3; a_i++){
						new_ptr->a[a_i] = 0;
					}
					new_ptr->b = (int **)malloc(sizeof(int *)* 2 * (domma_set_size - 1));//varsize᲻ͣı仯Ҳ֪ÿ
					for (int pp = 0; pp < domma_set_size - 1; pp++){
						new_ptr->b[2 * pp] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
						for (int i = 0; i < VARSIZE_MAXIMUM; i++){
							new_ptr->b[2 * pp][i] = 0;
						}
						new_ptr->b[2 * pp + 1] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
						for (int i = 0; i < VARSIZE_MAXIMUM; i++){
							new_ptr->b[2 * pp + 1][i] = 1;
						}
					}
					new_ptr->next = NULL;

					/*ڶһƥʽnew_ptr*/
					/*ڱʽѭ*/
					for (int tt = 0; tt < domma_set_size - 1; tt++){
						bool first_term = true;
						for (int mm = domma_set[tt] + 1; mm <= domma_set[tt + 1]; mm++){ //input[nn<=x<mm]һtermϵһ
							if (input[mm] == '+' || input[mm] == '-' || mm == domma_set[tt + 1]){
								if (first_term){
									nn = mm + 1;
									flag = -1;
									first_term = false;
									continue;
								}

								//termг˺ŵ
								int* multi_num = (int *)malloc(sizeof(int)* 10);
								multi_num[0] = 0;
								for (int ii = nn; ii < mm; ii++){
									if (input[ii] == '*'){
										multi_num[0]++;
										multi_num[multi_num[0]] = ii;
									}
								}
								//termûг˺ŵ
								if (multi_num[0] == 0){
									while (input[nn] == ' ') nn++;
									if (isdigit(input[nn])){ //ĸΪ֣һ
										int jj = 0;
										for (int ii = nn; ii < mm; ii++){
											if (input[ii] != ' '){
												input2[jj] = input[ii];
												jj++;
											}
										}
										input2[jj] = '\0';
										double temp = atof(input2);
										qresult = ftoq(temp);
										new_ptr->b[2 * tt][0] = flag * qresult[0];
										new_ptr->b[2 * tt + 1][0] = qresult[1];
										free(qresult);
									}
									else{ //ĸΪ֣һϵΪ1-1ı
										int jj = 0;
										for (int ii = nn; ii < mm; ii++){
											if (input[ii] != ' '){
												input2[jj] = input[ii];
												jj++;
											}
										}
										input2[jj] = '\0';
										int var_num = 0;//var_num0ʼ
										for (int ii = 0; ii < varsize; ii++){
											if (strcmp(input2, varnamelist[ii]) == 0){
												var_num = ii;
												break;
											}
										}
										//ͳphi,psiԱΪͳƹ׼
										if (inputrow == 5){
											variable_phi[var_num] = 1;
										}
										else{
											variable_psi[var_num] = 1;
										}
										new_ptr->b[2 * tt][var_num + 1] = flag;
										new_ptr->b[2 * tt + 1][var_num + 1] = 1;
									}
								}

								//term1˺ŵ˴⣬δͺֻ
								if (multi_num[0] == 1){
									while (input[nn] == ' ') nn++;
									if (isdigit(input[nn])){ //ĸΪ֣һ
										int jj = 0;
										for (int ii = nn; ii < multi_num[1]; ii++){
											if (input[ii] != ' '){
												input2[jj] = input[ii];
												jj++;
											}
										}
										input2[jj] = '\0';
										double temp = atof(input2);
										qresult = ftoq(temp);
									}
									else{ //˺֮ǰΪ
										printf("\nSyntax error at line %d.\n", error_line_record);
										exit(0);
									}
									// ȡ
									int jj = 0;
									for (int ii = multi_num[1] + 1; ii < mm; ii++){
										if (input[ii] != ' '){
											input2[jj] = input[ii];
											jj++;
										}
									}
									input2[jj] = '\0';
									int var_num = 0;//var_num0ʼ
									for (int ii = 0; ii < varsize; ii++){
										if (strcmp(input2, varnamelist[ii]) == 0){
											var_num = ii;
											break;
										}
									}
									//ͳphi,psiԱΪͳƹ׼
									if (inputrow == 5){
										variable_phi[var_num] = 1;
									}
									else{
										variable_psi[var_num] = 1;
									}
									new_ptr->b[2 * tt][var_num + 1] = flag * qresult[0];
									new_ptr->b[2 * tt + 1][var_num + 1] = qresult[1];
									free(qresult);
								}

								if (input[mm] == '-')
									flag = -1;//һε
								else
									flag = 1;
							}
							else if (input[mm] != ' '){
								first_term = false;
							}
						}
					}
					/*ڶ*/

					/*N_half(new_ptr)phi/psi*/
					if (inputrow == 5){
						new_ptr->a[1] = 1;
					}
					else{
						new_ptr->a[1] = -1;
					}

					/*2.5жǷظɽһŻ*/
					bool has_been_appeared = false; //
					int appeared_num = 0;
					if (N_half[func_num_temp] != NULL){
						Node * search_ptr = N_half[func_num_temp];
						do{
							bool this_has_been_appeared = true;
							for (int pp = 0; pp < domma_set_size - 1; pp++){
								for (int ii = 0; ii <= varsize; ii++){
									qresult = fraction_add(new_ptr->b[2 * pp][ii], new_ptr->b[2 * pp + 1][ii],
										-search_ptr->b[2 * pp][ii], search_ptr->b[2 * pp + 1][ii]);
									if (qresult[0] != 0){
										this_has_been_appeared = false;
										break;
									}
									free(qresult);
								}
							}
							if (this_has_been_appeared == true){
								appeared_num = search_ptr->a[0]; // ¼fӦı
								has_been_appeared = true;
								break;
							}
							if (search_ptr->next != NULL)
								search_ptr = search_ptr->next;
							else
								break;
						} while (1);
					}
					/*2.5*/

					if (has_been_appeared){
						int oewfjiwj = 0;
						while (varnamelist[appeared_num - 1][oewfjiwj] != '%')
							oewfjiwj++;
						for (int ii = tempa; ii <= tempb; ii++){
							input[ii] = ' ';
						}
						input[tempa] = '%';
						input[tempa + 1] = varnamelist[appeared_num - 1][oewfjiwj + 1];
						input[tempa + 2] = varnamelist[appeared_num - 1][oewfjiwj + 2];
					}
					else{
						/*ƥżеȥµı*/
						Node * old_ptr = N_half[func_num_temp];
						int name_houzhui = 0;
						while (old_ptr != NULL){
							old_ptr = old_ptr->next;
							name_houzhui++;
						}
						new_ptr->a[2] = name_houzhui + 1;
						if (name_houzhui >= 676){ //676 = 26^2
							printf("The uninterpreted function is too much to deal with, please contact to the me.\n");
							exit(0);
						}
						else{
							for (int ii = tempa; ii <= tempb; ii++){
								input[ii] = ' ';
							}
							input[tempa] = '%';
							input[tempa + 1] = 'a' + (name_houzhui / 26);
							input[tempa + 2] = 'a' + (name_houzhui % 26);
							varnamelist[varsize] = (char *)malloc(sizeof(char)* (tempa - func_name_search + 4));
							for (int ii = func_name_search, jj = 0; ii < tempa + 3; ii++, jj++){
								varnamelist[varsize][jj] = (char)input[ii];
							}
							varnamelist[varsize][tempa - func_name_search + 3] = '\0';


							new_ptr->a[0] = varsize + 1; //ӹ1
							varsize++;
						}
						/**

						/*Ĳnew_ptrŵN_halfУҪежϣN*/
						if (N_half[func_num_temp] == NULL){
							N_half[func_num_temp] = new_ptr;
						}
						else{
							old_ptr = N_half[func_num_temp];
							Node * N_new = (Node *)malloc(sizeof(Node));
							N_new->a = (int *)malloc(sizeof(int)* 9); //aд̺ʽߵԪ
							N_new->b = (int **)malloc(sizeof(int *)* 2 * domma_set_size);//varsize᲻ͣı仯Ҳ֪ÿ
							for (int pp = 0; pp < domma_set_size - 1; pp++){
								N_new->b[2 * pp] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
								for (int i = 0; i < VARSIZE_MAXIMUM; i++){
									N_new->b[2 * pp][i] = 0;
								}
								N_new->b[2 * pp + 1] = (int *)malloc(sizeof(int)* VARSIZE_MAXIMUM);
								for (int i = 0; i < VARSIZE_MAXIMUM; i++){
									N_new->b[2 * pp + 1][i] = 1;
								}
							}
							do{
								for (int pp = 0; pp < domma_set_size - 1; pp++){
									for (int ii = 0; ii <= varsize; ii++){
										qresult = fraction_add(new_ptr->b[2 * pp][ii], new_ptr->b[2 * pp + 1][ii],
											-old_ptr->b[2 * pp][ii], old_ptr->b[2 * pp + 1][ii]);
										if (N_new->b[2 * pp][ii] != 0){
											has_been_appeared = false;
										}
										N_new->b[2 * pp][ii] = qresult[0];
										N_new->b[2 * pp + 1][ii] = qresult[1];
										free(qresult);
									}
								}
								N_new->a[0] = old_ptr->a[0];
								N_new->a[1] = new_ptr->a[0];
								N_new->a[2] = new_ptr->a[1];
								N_new->a[3] = old_ptr->a[1];
								N_new->a[4] = varsize;
								N_new->a[5] = domma_set_size - 1;
								N_new->a[6] = new_ptr->a[2];
								N_new->a[7] = old_ptr->a[2];
								N_new->a[8] = func_num_temp;

								if (N_new->a[2] == 1){
									if (N_new->a[3] == 1){
										N_new->next = N_phi;
										N_phi = N_new;
									}
									else{
										N_new->next = N_mix;
										N_mix = N_new;
									}
								}
								else{
									if (N_new->a[3] == -1){
										N_new->next = N_psi;
										N_psi = N_new;
									}
									else{
										N_new->next = N_mix;
										N_mix = N_new;
									}
								}


								if (old_ptr->next != NULL)
									old_ptr = old_ptr->next;
								else
									break;
							} while (1);
							old_ptr->next = new_ptr;
							new_ptr->next = NULL;
						}
						/*Ĳ*/
					}
					/*¼ƥеıʽֽ*/
					stack_cap--;
				}
			}
		}

		int spaceEating = 0;

		for (int i = 0; i < inputtemp; i++, spaceEating++){
			if (input[i] == ' '){
				i++;
			}
			input[spaceEating] = input[i];
		}
		input[spaceEating] = '\0';
		inputtemp = spaceEating;

		int leixing = inputtemp - 3;
		int leixing2 = 0;
		if (input[leixing + 1] == '0'){
			if (input[leixing] == '='){
				if (input[leixing - 1] != '>'){
					leixing++;
					if (inputrow == 5){
						phi_equals[0]++;
						phi_equals[conssize + 1] = 1;
					}
					else{
						psi_equals[0]++;
						psi_equals[conssize + 1] = 1;
					}
				}
				double flag = 1.0;
				int terms = 0;
				if (inputrow == 5){
					for (int a = 0; a < leixing - 1; a++){
						if (input[a] == ' ') continue;
						if (input[a] == '+'){
							flag = 1;
							continue;
						}
						if (input[a] == '-') {
							flag = -1;
							continue;
						}
						//int examine_higher = 0;//ûиߴ
						int b = a; //abһterm
						int num = 0; // 0ֻг1ֻһ2
						int num1 = -1, num2;
						int input2len = 0;
						while (input[b] != ' ' && input[b] != '+' && input[b] != '-' && input[b] != '>'&& input[b] != '='){
							b++;
						}
						for (int i = a; i < b; i++){
							if (input[i] == '*'){
								if (num == 0){
									input2[input2len] = '\0';
									phi_constraints->c[conssize][terms] = flag * atof(input2);
								}
								else if (num == 1){
									input2[input2len] = '\0';
									for (num1 = 0; num1 < varsize; num1++){
										if (strcmp(varnamelist[num1], input2) == 0){
											break;
										}
									}
									//ͳphi,psiԱΪͳƹ׼
									if (inputrow == 5){
										variable_phi[num1] = 1;
									}
									else{
										variable_psi[num1] = 1;
									}
									num = 3;
								}
								else if (num == 2){
									examine_higher = 1;
									//input2[input2len] = '\0';
									//for (num2 = 0; num2 < varsize; num2++){
									//	if (strcmp(varnamelist[num2], input2) == 0){
									//		break;
									//	}
									//}
									//break;
								}
								else if (num >= 3){
									examine_higher = 1;
								}
								num++;
								input2len = 0;
							}
							else if (input[i] == '^'){
								input2[input2len] = '\0';
								for (num1 = 0; num1 < varsize; num1++){
									if (strcmp(varnamelist[num1], input2) == 0){
										break;
									}
								}

								//ͳphi,psiԱΪͳƹ׼
								if (inputrow == 5){
									variable_phi[num1] = 1;
								}
								else{
									variable_psi[num1] = 1;
								}

								num2 = num1;
								input2len = 0;
								num = 2;
								if (num >= 3){
									examine_higher = 1;
								}
								if (input[i + 1] != '2'){
									examine_higher = 1;
								}
								else{
									if (isdigit(input[i + 2])){
										examine_higher = 1;
									}
									else{
										if (input[i + 2] == '*'){
											examine_higher = 1;
										}
									}
								}
								break;
							}
							else{
								input2[input2len++] = input[i];
								if ((!isdigit(input2[0])) && num == 0){
									phi_constraints->c[conssize][terms] = flag;
									num++;
								}
							}
						}
						//if (examine_higher == 1){
						//	fclose(fp);
						//	if (webVersion){
						//		solve_higher_problem_for_web(myfilename);
						//		exit(666);
						//	}
						//	else{
						//		printf("%s", phipsiOutput);
						//		solve_higher_problem(myfilename);
						//		exit(2);
						//	}
						//}
						if (num == 0){
							input2[input2len] = '\0';
							phi_constraints->c[conssize][terms] = flag * atof(input2);
							phi_constraints->b[conssize][2 * terms] = 0;
							phi_constraints->b[conssize][2 * terms + 1] = 0;
						}
						if (num == 1){
							input2[input2len] = '\0';
							for (num1 = 0; num1 < varsize; num1++){
								if (strcmp(varnamelist[num1], input2) == 0){
									break;
								}
							}

							//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num1] = 1;
							}
							else{
								variable_psi[num1] = 1;
							}

							phi_constraints->b[conssize][2 * terms] = 0;
							phi_constraints->b[conssize][2 * terms + 1] = num1 + 1;
						}
						if (num == 2){ //
							phi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							phi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						if (num >= 3){ // c*x*y
							for (num2 = 0; num2 < varsize; num2++){
								if (strcmp(varnamelist[num2], input2) == 0){
									break;
								}
							}

							//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num2] = 1;
							}
							else{
								variable_psi[num2] = 1;
							}

							phi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							phi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						terms++;
						a = b - 1;
					}//phifor
					conssize++;
					phi_constraints->a[conssize] = terms;
				}
				else{
					for (int a = 0; a < leixing - 1; a++){
						if (input[a] == ' ') continue;
						if (input[a] == '+'){
							flag = 1;
							continue;
						}
						if (input[a] == '-') {
							flag = -1;
							continue;
						}
						//int examine_higher = 0;//ûиߴ
						int b = a; //abһterm
						int num = 0; // 0ֻг1ֻһ2
						int num1, num2;
						int input2len = 0;
						while (input[b] != ' ' && input[b] != '+' &&  input[b] != '-' && input[b] != '>' && input[b] != '='){
							b++;
						}
						for (int i = a; i < b; i++){
							if (input[i] == '*'){
								if (num == 0){
									input2[input2len] = '\0';
									psi_constraints->c[conssize][terms] = flag * atof(input2);
								}
								else if (num == 1){
									input2[input2len] = '\0';
									for (num1 = 0; num1 < varsize; num1++){
										if (strcmp(varnamelist[num1], input2) == 0){
											break;
										}
									}

									//ͳphi,psiԱΪͳƹ׼
									if (inputrow == 5){
										variable_phi[num1] = 1;
									}
									else{
										variable_psi[num1] = 1;
									}

									num = 3;
								}
								else if (num == 2){
									//input2[input2len] = '\0';
									//for (num2 = 0; num2 < varsize; num2++){
									//	if (strcmp(varnamelist[num2], input2) == 0){
									//		break;
									//	}
									//}
									examine_higher = 1;
									break;
								}
								else if (num >= 3){
									examine_higher = 1;
									break;
								}
								num++;
								input2len = 0;
							}
							else if (input[i] == '^'){
								input2[input2len] = '\0';
								for (num1 = 0; num1 < varsize; num1++){
									if (strcmp(varnamelist[num1], input2) == 0){
										break;
									}
								}

								//ͳphi,psiԱΪͳƹ׼
								if (inputrow == 5){
									variable_phi[num1] = 1;
								}
								else{
									variable_psi[num1] = 1;
								}

								num2 = num1;
								input2len = 0;
								num = 2;

								if (num >= 3){
									examine_higher = 1;
								}
								if (input[i + 1] != '2'){
									examine_higher = 1;
								}
								else{
									if (isdigit(input[i + 2])){
										examine_higher = 1;
									}
									else{
										if (input[i + 2] == '*'){
											examine_higher = 1;
										}
									}
								}
								break;
							}
							else{
								input2[input2len++] = input[i];
								if ((!isdigit(input2[0])) && num == 0){
									psi_constraints->c[conssize][terms] = flag;
									num++;
								}
							}
						}
						//if (examine_higher == 1){
						//	fclose(fp);
						//	if (webVersion){
						//		solve_higher_problem_for_web(myfilename);
						//		exit(666);
						//	}
						//	else{
						//		printf("%s", phipsiOutput);
						//		solve_higher_problem(myfilename);
						//		exit(2);
						//	}
						//}
						if (num == 0){
							input2[input2len] = '\0';
							psi_constraints->c[conssize][terms] = flag * atof(input2);
							psi_constraints->b[conssize][2 * terms] = 0;
							psi_constraints->b[conssize][2 * terms + 1] = 0;
						}
						if (num == 1){
							input2[input2len] = '\0';
							for (num1 = 0; num1 < varsize; num1++){
								if (strcmp(varnamelist[num1], input2) == 0){
									break;
								}
							}

							//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num1] = 1;
							}
							else{
								variable_psi[num1] = 1;
							}

							psi_constraints->b[conssize][2 * terms] = 0;
							psi_constraints->b[conssize][2 * terms + 1] = num1 + 1;
						}
						if (num == 2){
							psi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							psi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						if (num >= 3){
							for (num2 = 0; num2 < varsize; num2++){
								if (strcmp(varnamelist[num2], input2) == 0){
									break;
								}
							}
							//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num2] = 1;
							}
							else{
								variable_psi[num2] = 1;
							}

							psi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							psi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						terms++;
						a = b - 1;
					}//psifor
					conssize++;
					psi_constraints->a[conssize] = terms;
				}
			}
			else if (input[leixing] == '>'){
				double flag = 1.0;
				int terms = 0;
				if (inputrow == 5){
					for (int a = 0; a < leixing; a++){
						if (input[a] == ' ') continue;
						if (input[a] == '+'){
							flag = 1;
							continue;
						}
						if (input[a] == '-') {
							flag = -1;
							continue;
						}
						int b = a; //abһterm
						int num = 0; // 0ֻг1ֻһ2
						int num1, num2;
						int input2len = 0;
						while (input[b] != ' ' && input[b] != '+' &&  input[b] != '-' && input[b] != '>'){
							b++;
						}
						for (int i = a; i < b; i++){
							if (input[i] == '*'){
								if (num == 0){
									input2[input2len] = '\0';
									phi_constraints->c[conssize][terms] = flag * atof(input2);
								}
								if (num == 1){
									input2[input2len] = '\0';
									for (num1 = 0; num1 < varsize; num1++){
										if (strcmp(varnamelist[num1], input2) == 0){
											break;
										}
									}
									//ͳphi,psiԱΪͳƹ׼
									if (inputrow == 5){
										variable_phi[num1] = 1;
									}
									else{
										variable_psi[num1] = 1;
									}
									num = 3;
								}
								if (num == 2){
									input2[input2len] = '\0';
									for (num2 = 0; num2 < varsize; num2++){
										if (strcmp(varnamelist[num2], input2) == 0){
											break;
										}
									}
									//ͳphi,psiԱΪͳƹ׼
									if (inputrow == 5){
										variable_phi[num2] = 1;
									}
									else{
										variable_psi[num2] = 1;
									}
								}

								num++;
								input2len = 0;
							}
							else if (input[i] == '^'){
								input2[input2len] = '\0';
								for (num1 = 0; num1 < varsize; num1++){
									if (strcmp(varnamelist[num1], input2) == 0){
										break;
									}
								}
								//ͳphi,psiԱΪͳƹ׼
								if (inputrow == 5){
									variable_phi[num1] = 1;
								}
								else{
									variable_psi[num1] = 1;
								}
								num2 = num1;
								input2len = 0;
								num = 2;
							}
							else{
								input2[input2len++] = input[i];
								if ((!isdigit(input2[0])) && num == 0){
									phi_constraints->c[conssize][terms] = flag;
									num++;
								}
							}
						}
						if (num == 0){
							input2[input2len] = '\0';
							phi_constraints->c[conssize][terms] = flag * atof(input2);
							phi_constraints->b[conssize][2 * terms] = 0;
							phi_constraints->b[conssize][2 * terms + 1] = 0;
						}
						if (num == 1){
							input2[input2len] = '\0';
							for (num1 = 0; num1 < varsize; num1++){
								if (strcmp(varnamelist[num1], input2) == 0){
									break;
								}
							}
							//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num1] = 1;
							}
							else{
								variable_psi[num1] = 1;
							}
							phi_constraints->b[conssize][2 * terms] = 0;
							phi_constraints->b[conssize][2 * terms + 1] = num1 + 1;
						}
						if (num == 2){
							phi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							phi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						if (num >= 3){
							for (num2 = 0; num2 < varsize; num2++){
								if (strcmp(varnamelist[num2], input2) == 0){
									break;
								}
							}								//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num2] = 1;
							}
							else{
								variable_psi[num2] = 1;
							}
							phi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							phi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						terms++;
						a = b - 1;
					}//phifor
					conssize++;
					phi_constraints->a[conssize] = -terms;
				}
				else{
					for (int a = 0; a < leixing; a++){
						if (input[a] == ' ') continue;
						if (input[a] == '+'){
							flag = 1;
							continue;
						}
						if (input[a] == '-') {
							flag = -1;
							continue;
						}
						int b = a; //abһterm
						int num = 0; // 0ֻг1ֻһ2
						int num1, num2;
						int input2len = 0;
						while (input[b] != ' ' && input[b] != '+' &&  input[b] != '-' && input[b] != '>'){
							b++;
						}
						for (int i = a; i < b; i++){
							if (input[i] == '*'){
								if (num == 0){
									input2[input2len] = '\0';
									psi_constraints->c[conssize][terms] = flag * atof(input2);
								}
								if (num == 1){
									input2[input2len] = '\0';
									for (num1 = 0; num1 < varsize; num1++){
										if (strcmp(varnamelist[num1], input2) == 0){
											break;
										}
									}
									//ͳphi,psiԱΪͳƹ׼
									if (inputrow == 5){
										variable_phi[num1] = 1;
									}
									else{
										variable_psi[num1] = 1;
									}
									num = 3;
								}
								if (num == 2){
									input2[input2len] = '\0';
									for (num2 = 0; num2 < varsize; num2++){
										if (strcmp(varnamelist[num2], input2) == 0){
											break;
										}
									}
									//ͳphi,psiԱΪͳƹ׼
									if (inputrow == 5){
										variable_phi[num2] = 1;
									}
									else{
										variable_psi[num2] = 1;
									}
								}
								num++;
								input2len = 0;
							}
							else if (input[i] == '^'){
								input2[input2len] = '\0';
								for (num1 = 0; num1 < varsize; num1++){
									if (strcmp(varnamelist[num1], input2) == 0){
										break;
									}
								}
								//ͳphi,psiԱΪͳƹ׼
								if (inputrow == 5){
									variable_phi[num1] = 1;
								}
								else{
									variable_psi[num1] = 1;
								}
								num2 = num1;
								input2len = 0;
								num = 2;
							}
							else{
								input2[input2len++] = input[i];
								if ((!isdigit(input2[0])) && num == 0){
									psi_constraints->c[conssize][terms] = flag;
									num++;
								}
							}
						}
						if (num == 0){
							input2[input2len] = '\0';
							psi_constraints->c[conssize][terms] = flag * atof(input2);
							psi_constraints->b[conssize][2 * terms] = 0;
							psi_constraints->b[conssize][2 * terms + 1] = 0;
						}
						if (num == 1){
							input2[input2len] = '\0';
							for (num1 = 0; num1 < varsize; num1++){
								if (strcmp(varnamelist[num1], input2) == 0){
									break;
								}
							}
							//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num1] = 1;
							}
							else{
								variable_psi[num1] = 1;
							}
							psi_constraints->b[conssize][2 * terms] = 0;
							psi_constraints->b[conssize][2 * terms + 1] = num1 + 1;
						}
						if (num == 2){
							psi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							psi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						if (num >= 3){
							for (num2 = 0; num2 < varsize; num2++){
								if (strcmp(varnamelist[num2], input2) == 0){
									break;
								}
							}
							//ͳphi,psiԱΪͳƹ׼
							if (inputrow == 5){
								variable_phi[num2] = 1;
							}
							else{
								variable_psi[num2] = 1;
							}
							psi_constraints->b[conssize][2 * terms] = num1 < num2 ? num1 + 1 : num2 + 1;
							psi_constraints->b[conssize][2 * terms + 1] = num1 > num2 ? num1 + 1 : num2 + 1;
						}
						terms++;
						a = b - 1;
					}//psifor
					conssize++;
					psi_constraints->a[conssize] = -terms;
				}
			}
			else{
				printf("\nSyntax error at line %d.\n", error_line_record);
				exit(1);
			}
		}
		else{
			printf("\nSyntax error at line %d.\n", error_line_record);
			exit(1);
		}
		is_a_end--;
		if (is_a_end == 1){
			is_a_end--;
		}
		else if (is_a_end == -1){
			break;
		}

	}

	if (examine_higher == 1){
		fclose(fp);
		if (webVersion){
			solve_higher_problem_for_web(myfilename);
			exit(666);
		}
		else{
			printf("%s", phipsiOutput);
			solve_higher_problem(myfilename);
			exit(2);
		}
	}

	if (has_a_euf){
		/*ѵʽȥphi_equal_constraints*/
		phi_equal_constraints->a = (int *)malloc(sizeof(int)* (phi_equals[0] + 2));
		phi_equal_constraints->a[0] = phi_equals[0];
		phi_equal_constraints->b = (int **)malloc(sizeof(int *)* (phi_equals[0] + 1));
		phi_equal_constraints->c = (double **)malloc(sizeof(double *)* (phi_equals[0] + 1));
		for (int i = 1, j = 0; i <= phi_constraints->a[0]; i++){
			if (phi_equals[i] == 1){
				phi_equal_constraints->a[j + 1] = phi_constraints->a[i];
				phi_constraints->a[i] = 0;
				phi_equal_constraints->b[j] = phi_constraints->b[i - 1];
				phi_constraints->b[i - 1] = NULL;
				phi_equal_constraints->c[j] = phi_constraints->c[i - 1];
				phi_constraints->c[i - 1] = NULL;
				j++;
			}
		}

		/*ѵʽȥpsi_equal_constraints*/
		psi_equal_constraints->a = (int *)malloc(sizeof(int)* (psi_equals[0] + 2));
		psi_equal_constraints->a[0] = psi_equals[0];
		psi_equal_constraints->b = (int **)malloc(sizeof(int *)* (psi_equals[0] + 1));
		psi_equal_constraints->c = (double **)malloc(sizeof(double *)* (psi_equals[0] + 1));
		for (int i = 1, j = 0; i <= psi_constraints->a[0]; i++){
			if (psi_equals[i] == 1){
				psi_equal_constraints->a[j + 1] = psi_constraints->a[i];
				psi_constraints->a[i] = 0;
				psi_equal_constraints->b[j] = psi_constraints->b[i - 1];
				psi_constraints->b[i - 1] = NULL;
				psi_equal_constraints->c[j] = psi_constraints->c[i - 1];
				psi_constraints->c[i - 1] = NULL;
				j++;
			}
		}
	}
	else{ //ûeufƵʽ
		phi_constraints->a = (int *)realloc(phi_constraints->a, sizeof(int)* (phi_constraints->a[0] + 2 + phi_equals[0]));
		phi_constraints->b = (int **)realloc(phi_constraints->b, sizeof(int *)* (phi_constraints->a[0] + 1 + phi_equals[0]));
		for (int i = 0; i < phi_equals[0]; i++){
		}
		phi_constraints->c = (double **)realloc(phi_constraints->c, sizeof(double *)* (phi_constraints->a[0] + 1 + phi_equals[0]));
		for (int i = 1, j = phi_constraints->a[0]; i <= phi_constraints->a[0]; i++){
			if (phi_equals[i] == 1){
				phi_constraints->a[j + 1] = phi_constraints->a[i];
				phi_constraints->b[j] = (int *)malloc(sizeof(int)*(phi_constraints->a[i] + 1) * 2);
				phi_constraints->c[j] = (double *)malloc(sizeof(double)*(phi_constraints->a[i] + 1));
				for (int k = 0; k < phi_constraints->a[i]; k++){
					phi_constraints->b[j][2 * k] = phi_constraints->b[i - 1][2 * k];
					phi_constraints->b[j][2 * k + 1] = phi_constraints->b[i - 1][2 * k + 1];
					phi_constraints->c[j][k] = -phi_constraints->c[i - 1][k];
				}
				j++;
			}
		}
		phi_constraints->a[0] = phi_constraints->a[0] + phi_equals[0];

		psi_constraints->a = (int *)realloc(psi_constraints->a, sizeof(int)* (psi_constraints->a[0] + 2 + psi_equals[0]));
		psi_constraints->b = (int **)realloc(psi_constraints->b, sizeof(int *)* (psi_constraints->a[0] + 1 + psi_equals[0]));
		psi_constraints->c = (double **)realloc(psi_constraints->c, sizeof(double *)* (psi_constraints->a[0] + 1 + psi_equals[0]));
		for (int i = 1, j = psi_constraints->a[0]; i <= psi_constraints->a[0]; i++){
			if (psi_equals[i] == 1){
				psi_constraints->a[j + 1] = psi_constraints->a[i];
				psi_constraints->b[j] = (int *)malloc(sizeof(int)*(psi_constraints->a[i] + 1) * 2);
				psi_constraints->c[j] = (double *)malloc(sizeof(double)*(psi_constraints->a[i] + 1));
				for (int k = 0; k < psi_constraints->a[i]; k++){
					psi_constraints->b[j][2 * k] = psi_constraints->b[i - 1][2 * k];
					psi_constraints->b[j][2 * k + 1] = psi_constraints->b[i - 1][2 * k + 1];
					psi_constraints->c[j][k] = -psi_constraints->c[i - 1][k];
				}
				j++;
			}
		}
		psi_constraints->a[0] = psi_constraints->a[0] + psi_equals[0];
	}

	//int examine_more = 0;
	//for (int i = 0; i < phi_equal_constraints->a[0]; i++){
	//	for (int j = 0; j < phi_equal_constraints->a[i + 1]; j++){
	//		if (phi_equal_constraints->b[i][2 * j]>0){
	//			examine_more = 1;
	//		}
	//	}
	//}
	//for (int i = 0; i < psi_equal_constraints->a[0]; i++){
	//	for (int j = 0; j < psi_equal_constraints->a[i + 1]; j++){
	//		if (psi_equal_constraints->b[i][2 * j]>0){
	//			examine_more = 1;
	//		}
	//	}
	//}
	//if (examine_more == 1){
	//	solve_higher_problem(myfilename);
	//	exit(0);
	//}



	/* Ĵʹ>=0Ĳʽǰ>0Ĳʽں*/
	for (int i = 1, j = phi_constraints->a[0]; i < j;){
		if (phi_constraints->a[i] <= 0){
			if (phi_constraints->a[j]>0){
				int temp = phi_constraints->a[i];
				phi_constraints->a[i] = phi_constraints->a[j];
				phi_constraints->a[j] = temp;
				int * tempp = phi_constraints->b[i - 1];
				phi_constraints->b[i - 1] = phi_constraints->b[j - 1];
				phi_constraints->b[j - 1] = tempp;
				double *tempp2 = phi_constraints->c[i - 1];
				phi_constraints->c[i - 1] = phi_constraints->c[j - 1];
				phi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	for (int i = 1, j = phi_constraints->a[0]; i < j;){
		if (phi_constraints->a[i] == 0){
			if (phi_constraints->a[j] < 0){
				int temp = phi_constraints->a[i];
				phi_constraints->a[i] = phi_constraints->a[j];
				phi_constraints->a[j] = temp;
				int * tempp = phi_constraints->b[i - 1];
				phi_constraints->b[i - 1] = phi_constraints->b[j - 1];
				phi_constraints->b[j - 1] = tempp;
				double *tempp2 = phi_constraints->c[i - 1];
				phi_constraints->c[i - 1] = phi_constraints->c[j - 1];
				phi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	if (has_a_euf){
		phi_constraints->a[0] = phi_constraints->a[0] - phi_equals[0];
	}

	for (int i = 1, j = psi_constraints->a[0]; i < j;){
		if (psi_constraints->a[i] <= 0){
			if (psi_constraints->a[j] > 0){
				int temp = psi_constraints->a[i];
				psi_constraints->a[i] = psi_constraints->a[j];
				psi_constraints->a[j] = temp;
				int * tempp = psi_constraints->b[i - 1];
				psi_constraints->b[i - 1] = psi_constraints->b[j - 1];
				psi_constraints->b[j - 1] = tempp;
				double * tempp2 = psi_constraints->c[i - 1];
				psi_constraints->c[i - 1] = psi_constraints->c[j - 1];
				psi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	for (int i = 1, j = psi_constraints->a[0]; i < j;){
		if (psi_constraints->a[i] == 0){
			if (psi_constraints->a[j] < 0){
				int temp = psi_constraints->a[i];
				psi_constraints->a[i] = psi_constraints->a[j];
				psi_constraints->a[j] = temp;
				int * tempp = psi_constraints->b[i - 1];
				psi_constraints->b[i - 1] = psi_constraints->b[j - 1];
				psi_constraints->b[j - 1] = tempp;
				double * tempp2 = psi_constraints->c[i - 1];
				psi_constraints->c[i - 1] = psi_constraints->c[j - 1];
				psi_constraints->c[j - 1] = tempp2;
				i++; j--;
			}
			else{
				j--;
			}
		}
		else{
			i++;
		}
	}
	if (has_a_euf){
		psi_constraints->a[0] = psi_constraints->a[0] - psi_equals[0];
	}

	//Node * tmp = N_half[0];
	//while (tmp != NULL){
	//	printf("f   %d   %d   %d\n", tmp->a[0], tmp->a[1], tmp->a[2]);
	//	tmp = tmp->next;
	//}

	//printf(".\n");
	//printf("phi:\n");
	//printSystem(phi_constraints);
	//printf("psi:\n");
	//printSystem(psi_constraints);
	//printf("\n");
	OutputH_half();

	Node * result = ig_cqi2(varsize, phi_constraints, psi_constraints);

	time_finish = clock();

	if (result == NULL){
		//printf("\nThere's no solution.\n");	
		if (webVersion){
			solve_higher_problem_for_web(myfilename);
			exit(666);
		}
		else{
			printf("%s", phipsiOutput);
			solve_higher_problem(myfilename);
			exit(2);
		}
	}
	printf("%s", phipsiOutput);

	//varnamelist
	for (int i = 0; i < funcsize; i++){
		Node * tempNode = N_half[i];
		while (tempNode != NULL){
			int numberOfVar = tempNode->a[0] - 1;
			varnamelist[numberOfVar] = realloc(varnamelist[numberOfVar], sizeof(char)* 200);
			sprintf(varnamelist[numberOfVar], "%s(", funcnamelist[i]);
			int ret1 = strlen(funcnamelist[i]) + 1;
			char * receiveChar = (char *)malloc(sizeof(char)* 200);
			int notFirstOne = 0;
			for (int j = 0; j <= varsize; j++){
				if (tempNode->b[0][j] != 0){
					if (tempNode->b[0][j] > 0 && notFirstOne){
						varnamelist[numberOfVar][ret1] = '+';
						ret1++;
					}
					sprintf(receiveChar, "%.6lf", (double)tempNode->b[0][j] / (double)tempNode->b[1][j]);
					for (int k = 0; k < 8; k++){
						varnamelist[numberOfVar][k + ret1] = receiveChar[k];
					}
					ret1 += 8;
					if (j != 0){
						varnamelist[numberOfVar][ret1] = '*';
						ret1++;
					}
					if (j != 0){
						for (int k = 0; k < strlen(varnamelist[j - 1]); k++){
							varnamelist[numberOfVar][k + ret1] = varnamelist[j - 1][k];
						}
						ret1 += strlen(varnamelist[j - 1]);
					}
					notFirstOne = 1;
				}
			}
			varnamelist[numberOfVar][ret1] = ')';
			ret1++;
			varnamelist[numberOfVar][ret1] = '\0';
			tempNode = tempNode->next;
		}
	}

	//ͳƹδͺ
	for (int i = 0; i < funcsize; i++){
		if (function_list_phi[i] == 1 && function_list_psi[i] == 1){
			function_list_common[i] = 1;
		}
	}

	for (int i = 0; i < original_varsize; i++){
		if (variable_phi[i] == 1 && variable_psi[i] == 1){
			variable_common[i] = 1;
		}
	}


	printf("\ncommon symbols: [");
	int isFirstOutput = 0;
	for (int i = 0; i < original_varsize; i++){
		if (variable_common[i] == 1){
			if (isFirstOutput){
				printf(" ");
			}
			printf("%s", varnamelist[i]);
			isFirstOutput = 1;
		}
	}
	for (int i = 0; i < funcsize; i++){
		if (function_list_common[i] == 1){
			if (isFirstOutput){
				printf(" ");
			}
			printf("%s", funcnamelist[i]);
			isFirstOutput = 1;
		}
	}
	printf("]\n");
	//for (int i = 0; i < varsize; i++){
	//	printf("%s\n", varnamelist[i]);
	//}

	//system("Pause");
	printf("\n\nInterpolant:\n\n");

	//outerTrueValue = (int *)malloc(sizeof(int)* 100);
	//for (int i = 0; i < 100; i++){
	//	outerTrueValue[i] = -2;
	//}

	//print_examine(result);

	//printf("\n");
	//for (int i = 0; i < 5; i++){
	//	printf("outerTrueValue[%d] = %d\n",i,outerTrueValue[i]);
	//}
	//hasprintsth = 0;

	/*
	 redlog
	 */
	FILE * fileForRedlog = fopen("FileForRedlog.txt", "w+");
	if (fileForRedlog == NULL){
		myprint2(result);
	}
	else{

		fprintf(fileForRedlog, "rlset r$;\n");
		fprintf(fileForRedlog, "off nospilt;\n");
		fprintf(fileForRedlog, "off nat;\n");
		fprintf(fileForRedlog, "on rlsism;\n");
		fprintf(fileForRedlog, "operator ");

		for (int i = 0; i < funcsize; i++){
			if (function_list_common[i] == 1){
				if (isFirstOutput){
					fprintf(fileForRedlog, " ");
				}
				fprintf(fileForRedlog, "%s", funcnamelist[i]);
				isFirstOutput = 1;
			}
		}

		fprintf(fileForRedlog, ";\n");

		fprintf(fileForRedlog, "out temp;\n");
		fprintf(fileForRedlog, "rlsimpl (");


		fshowToFile(fileForRedlog, result);
		fprintf(fileForRedlog, ");\n");

		fprintf(fileForRedlog, "shut temp;\n");

		fclose(fileForRedlog);

		system("reduce.exe FileForRedlog.txt");

		FILE * fileForRedlog2 = fopen("temp", "r+");
		if (fileForRedlog2 == NULL){
			myprint2(result);
		}
		else{
			inputtemp = 0;
			while (fgetc(fileForRedlog2) != '\n');

			int starFlag = 0;
			while ((input[inputtemp] = fgetc(fileForRedlog2)) != '$'){
				if (input[inputtemp] == '\n'){
					continue;
				}
				if (input[inputtemp] == '*'){
					if (starFlag == 0){
						starFlag = 1;
					}
					else{
						starFlag = 0;
						inputtemp--;
						input[inputtemp] = '^';
					}
				}
				else{
					starFlag = 0;
				}
				if (input[inputtemp] == 'd' && inputtemp >= 3 && input[inputtemp - 1] == 'n' && input[inputtemp - 2] == 'a'){
					inputtemp--;
					input[inputtemp - 1] = '/';
					input[inputtemp] = '\\';
				}
				if (input[inputtemp] == 'r' && inputtemp >= 2 && input[inputtemp - 1] == 'o'){
					input[inputtemp - 1] = '\\';
					input[inputtemp] = '/';
				}
				inputtemp++;
			}
			if (inputtemp >= 0){
				input[inputtemp] = '\0';
				printf("%s", input);
			}
			else{
				myprint2(result);
			}
			fclose(fileForRedlog2);
		}

	}


	/*
	 redlog
	 */

	//myprint2(result);

	//bool ifFinalResultTrue = false;
	//if (hasprintsth == 0){
	//	int outerWithCounter = 0;
	//	while (outerTrueValue[outerWithCounter] != -2){
	//		if (outerTrueValue[outerWithCounter] == 0){
	//			ifFinalResultTrue = true;
	//			hasprintsth = 1;
	//			break;
	//		}
	//		if (outerTrueValue[outerWithCounter] != -1){
	//			hasprintsth = 1;
	//		}
	//		outerTrueValue++;
	//	}
	//	if (hasprintsth == 0){
	//		printf("No interpolant is found.");
	//	}
	//}
	//if (hasprintsth && ifFinalResultTrue){
	//	printf("true");
	//}

	printf("\n\n\n");

	printf("Time: %lf seconds.\n", (double)(time_finish - time_start) / CLOCKS_PER_SEC);

	if (!webVersion){
		printf("\nSee in %s for intermediate results.\n\n", foutname);
	}

	if (fp_show){
		fprintf(fp_show, "\n\n\nInterpolant:\n");
		fshow(result);
	}

	fclose(fp);

	if (fp_show){
		fclose(fp_show);
	}

	if (webVersion){
		remove(foutname);
	}

	//free
	//free(phi_constraints->a);
	//for (int i = 0; i <; i++){
	//	free(phi_constraints->b[i]);

	//}

}

int main(int argc, char ** argv)
{
	//SetErrorMode(SEM_NOGPFAULTERRORBOX | SEM_NOGPFAULTERRORBOX);
	//HeapSetInformation(NULL, HeapEnableTerminationOnCorruption, NULL, 0);
	//const char * myfilename = { "7.1subproblem1.txt\0" };
	//interp2(myfilename);
	//printf(" ------------------------------------------------------------------------\n");
	//printf("|                                                                        |\n");
	//printf("|       NLFIntp: Synthesizing Interpolants for Nonlinear Formulas        |\n");
	//printf("|                                                                        |\n");
	//printf(" ------------------------------------------------------------------------\n");


		inputType = 0;
		webVersion = 0;
		//WEB_VERSION

		if (argc > 1){

			if (argc >= 3){
				if (argv[2][0] == '1'){
					inputType = 1;
				}
				//printf("inputType = %d\n", inputType);
				webVersion = 1;
			}
			else{
				printf(" ------------------------------------------------------------------------\n");
				printf("|                                                                        |\n");
				printf("|       NLFIntp: Synthesizing Interpolants for Nonlinear Formulas        |\n");
				printf("|                                                                        |\n");
				printf(" ------------------------------------------------------------------------\n");
			}

			if (inputType){
				clock_t time_start, time_finish;

				time_start = clock();
				//parseProblem(argv[1]);

				char useSOS3Filename[80];
				sprintf(useSOS3Filename, "SOS3.exe %s", argv[1]);
				system(useSOS3Filename);

				time_finish = clock();
				printf("\n\nTime: %lf seconds.\n", (double)(time_finish - time_start) / CLOCKS_PER_SEC);
			}
			else{
				interp2(argv[1]);
				///printf("%s", argv[1]);
			}

		}
		else{
			printf(" ------------------------------------------------------------------------\n");
			printf("|                                                                        |\n");
			printf("|       NLFIntp: Synthesizing Interpolants for Nonlinear Formulas        |\n");
			printf("|                                                                        |\n");
			printf(" ------------------------------------------------------------------------\n");
			char * fileinput = (char *)malloc(sizeof(char)* 500);

			printf("\nPlease specify the input file: ");
			scanf("%s", fileinput);
			printf("\n");
			interp2(fileinput);

			system("Pause");


		}

		remove("prob.sol");
		remove("prob.dat-s");
		//remove("temp");
		//remove("FileForRedlog.txt");
	

	return 0;
}

