#include "qcount.h"

void overflowChange(int * up, int* down)
{
	double temp = (double)(*up) / (double)(*down);
	int * qresult = ftoq(temp);
	*up = qresult[0];
	*down = qresult[1];
	free(qresult);
	return;
}

int * fraction_add(int up1, int down1, int up2, int down2)
{
	int * result = (int *)malloc(3 * sizeof(int));

	if (up1 > 32768 || down1 > 32768) {
		overflowChange(&up1, &down1);
	}
	if (up2 > 32768 || down2 > 32768) {
		overflowChange(&up2, &down2);
	}
	result[0] = up1 * down2 + up2 * down1;
	if (result[0] == 0){
		result[1] = 1;
	}
	else{
		result[1] = down1 * down2;
		int a = gcd(result[0], result[1]);
		if (a > 0){
			result[0] = result[0] / a;
			result[1] = result[1] / a;
		}
		else{
			result[0] = -result[0] / a;
			result[1] = -result[1] / a;
		}
	}

	return result;
}

int gcd(int a, int b){
	/*ĸԼaΪԼ*/
	int c;
	while (b != 0)  /* Ϊ0ֱΪ0 */
	{
		c = a%b; a = b;  b = c;
	}
	if (a > 0)
		return a;
	else
		return -a;
}