#include "qcount.h"

int * ftoq(double r)
{
	int minus = 0;
	if (r < 0) {
		r = -r;
		minus = 1;
	}
	int * result = (int *)malloc(sizeof(int)* 3);
	int a = 0;
	double b = 0;
	int h0 = 0, h1 = 1, k0 = 1, k1 = 0;
	int h2 = 0, k2 = 0;
	double tem = r;
	while (1){
		a = (int)tem;
		if (a == INT_MIN || a > A_BIG_NUM){
			result[0] = h1;
			result[1] = k1;
			if (minus) {
				result[0] = -result[0];
			}
			return result;
		}
		b = tem - (double)a;
		h2 = a*h1 + h0;
		k2 = a*k1 + k0;
		if (k2 > DENOMINATOR_MAXIMUM){
			break;
		}
		h0 = h1;
		k0 = k1;
		h1 = h2;
		k1 = k2;
		if (b == 0){
			break;
		}
		tem = 1 / b;
	}
	result[0] = h1;
	result[1] = k1;
	if (minus) {
		result[0] = -result[0];
	}
	return result;
}