#include "higher.h"

int solve_higher_problem(const char * myfilename)
{
	int error_line_record = 0;
	int inputExamine = 0;

	printf("\nThe involved polynimials are not concave quadratic, you may type:\n\'y\': to create a new file \"more_");
	printf(myfilename);
	printf("\" where you need to specify several parameters, or \n\'n\': to exit and check your input.\n\n");

	char * jjjj = (char *)malloc(sizeof(char)* 10);

	while (1){
		scanf_s("%s", jjjj, 10);
		if (jjjj[0] == 'y'){
			break;
		}
		else if (jjjj[0] == 'n'){
			exit(0);
		}
		else{
			printf("please input again.\n");
		}
	}

	char * input = (char *)malloc(sizeof(char)* 300);
	int inputsize = 0;
	char * input2 = (char *)malloc(sizeof(char)* 300);


	//FILE * fp = fopen(myfilename, "r");
	char * more_fname = (char *)malloc(sizeof(char)*(strlen(myfilename) + 7));
	more_fname[0] = 'm';
	more_fname[1] = 'o';
	more_fname[2] = 'r';
	more_fname[3] = 'e';
	more_fname[4] = '_';
	for (int i = 0; i <= strlen(myfilename); i++){
		more_fname[i + 5] = myfilename[i];
		if (i == strlen(myfilename)){
			more_fname[i + 5] = '\0';
		}
	}
	FILE * more_fp = fopen(more_fname, "w");

	// head
	fprintf(more_fp, "# Fill this template file please.\n\n");

	// Variable List
	fprintf(more_fp, "A = [");
	for (int i = 0; i < varsize; i++){
		if (i){
			fprintf(more_fp, " ");
		}
		fprintf(more_fp, "%s", varNameList[i]);
	}
	fprintf(more_fp, "]\n\n");


	int scan_index;
	if (phipsiOutput[0] == '\n'){
		scan_index = 1;
	}
	else {
		scan_index = 0;
	}
	int phi_to_psi = 0;

	// phi
	int fNum = 0;
	inputsize = 0;
	for (; scan_index < phipsiOutputCapacity; scan_index++) {
		if (phipsiOutput[scan_index] == '\n') {
			if (phi_to_psi) {
				break;
			}
			else {
				phi_to_psi = 1;
			}
			if (inputsize >= 3){
				if (input[inputsize - 3] == '>') {
					// >=0
					fNum++;
					input[inputsize - 3] = '\0';
					fprintf(more_fp, "f%d = %s\n", fNum, input);
					inputsize = 0;
				}
				else if (input[inputsize - 2] == '>') {
					// >0
					fNum++;
					input[inputsize - 2] = '\0';
					fprintf(more_fp, "f%d = %s\n", fNum, input);
					inputsize = 0;
				}
				else {
					// =0
					fNum++;
					input[inputsize - 2] = '\0';
					fprintf(more_fp, "f%d = %s\n", fNum, input);
					inputsize = 0;
				}
			}
			else{
				continue;
			}
		}
		else if (phipsiOutput[scan_index] == ':') {
			inputsize = 0;
		}
		else {
			phi_to_psi = 0;
			input[inputsize] = phipsiOutput[scan_index];
			inputsize++;
		}
	}


	/*psi*/
	int hNum = 0;
	inputsize = 0;
	for (; scan_index < phipsiOutputCapacity; scan_index++) {
		if (phipsiOutput[scan_index] == '\n') {
			if (inputsize >= 3){
				if (input[inputsize - 3] == '>') {
					// >=0
					hNum++;
					input[inputsize - 3] = '\0';
					fprintf(more_fp, "h%d = %s\n", hNum, input);
					inputsize = 0;
				}
				else if (input[inputsize - 2] == '>') {
					// >0
					hNum++;
					input[inputsize - 2] = '\0';
					fprintf(more_fp, "h%d = %s\n", hNum, input);
					inputsize = 0;
				}
				else {
					// =0
					hNum++;
					input[inputsize - 2] = '\0';
					fprintf(more_fp, "h%d = %s\n", hNum, input);
					inputsize = 0;
				}
			}
			else{
				continue;
			}
		}
		else if (phipsiOutput[scan_index] == ':') {
			inputsize = 0;
		}
		else {
			input[inputsize] = phipsiOutput[scan_index];
			inputsize++;
		}
	}


	fprintf(more_fp, "\n# Monomial templates (you can add more in the same form).\n");
	//fprintf(more_fp, "M1 = monomial(A, [0])\n");
	//fprintf(more_fp, "M2 = monomial(A, [0 1])\n");
	//fprintf(more_fp, "M3 = monomial(A, [0 1 2])\n");
	for (int i = 0; i <= 4; i++){
		fprintf(more_fp, "M%d = monomial(A, [", i);
		for (int j = 0; j <= i; j++){
			fprintf(more_fp, "%d", j);
			if (j != i){
				fprintf(more_fp, " ");
			}
		}
		fprintf(more_fp, "])\n");
	}
	fprintf(more_fp, "\n");

	fprintf(more_fp, "# Set polynomial templates by replacing '?' with ");
	int Mnum = 2;
	for (int i = 0; i <= Mnum; i++){
		fprintf(more_fp, "M%d", i);
		if (i == Mnum){
			fprintf(more_fp, " ");
		}
		else 		if (i == Mnum - 1){
			fprintf(more_fp, " or ");
		}
		else{
			fprintf(more_fp, ", ");
		}
	}
	fprintf(more_fp, "etc.\n");

	fprintf(more_fp, "s0 = sos(?)\n");

	for (int i = 0; i < fNum; i++){
		if (phi_equals[i + 1]){
			fprintf(more_fp, "s%d = poly(?)\n", i + 1);
		}
		else {
			fprintf(more_fp, "s%d = sos(?)\n", i + 1);
		}
	}

	for (int i = 0; i < hNum; i++){
		if (psi_equals[i + 1]){
			fprintf(more_fp, "t%d = poly(?)\n", i + 1);
		}
		else {
			fprintf(more_fp, "t%d = sos(?)\n", i + 1);
		}
	}

	fprintf(more_fp, "\ninterp(s0");
	for (int i = 0; i < fNum; i++){
		fprintf(more_fp, "+f%d*s%d", i + 1, i + 1);
	}
	fprintf(more_fp, ",");
	for (int i = 0; i < hNum; i++){
		if (i == 0)
			fprintf(more_fp, "h%d*t%d", i + 1, i + 1);
		else
			fprintf(more_fp, "+h%d*t%d", i + 1, i + 1);
	}
	fprintf(more_fp, ")\n");

	fclose(more_fp);

	printf("Type \'y\' again after you finish editing the new file.\n");
	
	while (1){
		scanf_s("%s", jjjj, 10);
		if (jjjj[0] == 'y'){
			break;
		}
		else if (jjjj[0] == 'n'){
			exit(0);
		}
		else{
			printf("please input again.\n");
		}
	}

	//parseProblem(more_fname);

	char useSOS3Filename[80];
	sprintf(useSOS3Filename, "SOS3.exe %s", more_fname);
	system(useSOS3Filename);

	return 0;
}



